/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@Fgcc -o Program_0 Source_Program_0.c
  
*/
#include <stdio.h>
#define PATTERN (0x0ABCDEF00)	// 6  
#define COUNT   (10)
static int a,b,c,d,A,B,C,D,E,F,X;
static struct {int a,b;} found[COUNT];

static void mul11() { A = (a * c) << 16; }
static void mul12() { B = (a * d) << 8; }
static void mul21() { C = (c * b) << 8; }
static void mul22() { D = (b * d); }
static void addAB() { E = (A + B); }
static void addCD() { F = (C + D); }
static void addEF() { X = (E + F); }
static int  check() { return !(X ^ PATTERN); }

void main(void)
{
  unsigned int i,j,count;

  count = COUNT;
  for ( i = 0 ; count && i <= 0xFFFF ; i++ )
    for ( j = 0 ; count && j <= 0xFFFF ; j++ )
    {
      a = i >> 8;	// 1oCgo(ӏ)
      b = i & 0xFF;	// 1oCgo(Ӊ)
      c = j >> 8;	// 1oCgo(Eӏ)
      d = j & 0xFF;	// 1oCgo(EӉ)
      mul22();		// ZP(ʁ~)
      mul12();		// ZQ(ʁ~) << 8
      mul21();		// ZR(ʁ~) << 8
      mul11();		// ZS(ʁ~) << 16
      addCD();		// ZP(ZP{ZR)
      addAB();		// ZQ(ZQ{ZS)
      addEF();		// ZR(ZP{ZQ)
      if( check() )
      {
	count--;
	found[count].a = i;
	found[count].b = j;
	printf("%8.8X = %4.4X * %4.4X\n",X,i,j);
      }
    }
  return;
}
